<template>
    <div>
        <div class="row">
            <label>Срок действия</label>
        </div>
        <div class="row">
            <div class="columns six">
                <select id="valid_month"
                        class="drop-date"
                        name="valid_month"
                        v-validate="'required'"
                        data-vv-delay="200"
                        :vValidateRules="'required'"
                        @change="$emit('getDropDate', {month: month, year: year})"
                        v-model.number="month">
                    <option :value="month" v-for="month in months" :key="month">{{month}}</option>
                </select>
                <validate-message v-show="vErrors.has('valid_month')">
                    {{ vErrors.first('valid_month') ? 'Обязательное поле' : '' }}
                </validate-message>
            </div>
            <div class="columns six">
                <select id="valid_year"
                        name="valid_year"
                        class="drop-date"
                        data-vv-delay="200"
                        :vValidateRules="'required'"
                        v-validate="'required'"
                        @change="$emit('getDropDate', {month: month, year: year})"
                        v-model.number="year"
                >
                    <option :value="year" v-for="year in years" :key="year">{{year}}</option>
                </select>
                <validate-message v-show="vErrors.has('valid_year')">
                    {{ vErrors.first('valid_year') ? 'Обязательное поле' : '' }}
                </validate-message>
            </div>
        </div>
    </div>
</template>

<script>

    export default {
        name: 'DropDate',
        data() {
            return {
                year: '',
                month: ''
            };
        },
        computed: {
            months() {
                if (this.year && this.year.toString() === this.$dayjs().format('YY')) {
                    return this.range(Number(this.$dayjs().format('M')), 12);
                }
                return this.range(1, 12);
            },

            years() {
                return this.range(new Date().getFullYear() - 2000, new Date().getFullYear() - 2000 + 10);
            }
        },

        methods: {
            /**
             *
             * @param {number} f
             * @param {number} to
             * @returns {Array} {number}
             */
            range(f, to) {
                let array = [];
                for (let i = f; i <= to; i++) {
                    array.push(String(i));
                }
                return array;
            }
        }
    };
</script>
